jQuery(document).ready(function($) {
    var chartInstance = null; // Déclaration de chartInstance en dehors de la fonction

       

        // Récupérer les valeurs des champs de date et du type de statistique
        var startDate = $('#start_date').val();
        var endDate = $('#end_date').val();
        var statType = $('#stat_type').val();
        var accessToken = youtubeStatsData.access_token; // Le jeton d'accès OAuth2

        // Vérifier si tous les champs sont remplis
        if (!startDate || !endDate || !statType || !accessToken) {
            alert('Veuillez remplir toutes les informations.');
            return;
        }

        // Faire l'appel AJAX pour récupérer les statistiques
        $.ajax({
            url: youtubeStatsData.ajax_url,
            method: 'POST',
            data: {
                action: 'fetch_youtube_stats',
                start_date: startDate,
                end_date: endDate,
                stat_type: statType,
                access_token: accessToken
            },
            success: function(response) {
                if (response.success) {
                    // Afficher les statistiques dans le graphique
                    displayStats(response.data.rows, statType);
                } else {
                    alert('Erreur: ' + response.data);
                }
            },
            error: function(xhr, status, error) {
                alert('Une erreur s\'est produite. Veuillez réessayer.'+ error);
            }
        });
    
    // Lors du clic sur le bouton pour afficher les statistiques
    $('#stat_type, #start_date, #end_date').on('change', function(e) {
        e.preventDefault();

        // Récupérer les valeurs des champs de date et du type de statistique
        var startDate = $('#start_date').val();
        var endDate = $('#end_date').val();
        var statType = $('#stat_type').val();
        
        var accessToken = youtubeStatsData.access_token; // Le jeton d'accès OAuth2

        // Vérifier si tous les champs sont remplis
        if (!startDate || !endDate || !statType || !accessToken) {
            alert('Veuillez remplir toutes les informations.');
            return;
        }

        // Faire l'appel AJAX pour récupérer les statistiques
        $.ajax({
            url: youtubeStatsData.ajax_url,
            method: 'POST',
            data: {
                action: 'fetch_youtube_stats',
                start_date: startDate,
                end_date: endDate,
                stat_type: statType,
                access_token: accessToken
            },
            success: function(response) {
                if (response.success) {
                    // Afficher les statistiques dans le graphique
                    displayStats(response.data.rows, statType);
                } else {
                    alert('Erreur: ' + response.data);
                }
            },
            error: function(xhr, status, error) {
                alert('Une erreur s\'est produite. Veuillez réessayer.'+ error);
            }
        });
    });

    // Fonction pour afficher les statistiques dans le graphique
    function displayStats(data, statType) {
        var ctx = document.getElementById('youtube-stats-chart').getContext('2d');

        // Réinitialiser ou créer un graphique
        if (chartInstance !== null) {
            chartInstance.destroy(); // Détruire le graphique précédent s'il existe
        }

        var labels = [];
        var values = [];
        var annotations = [];

        // Extraire les données du tableau de réponse
        $.each(data, function(index, row) {
            labels.push(row[0]); // La date
            values.push(row[1]); // La valeur (vues, heures de visionnage, abonnés)
        });

        // Appliquer une couleur spécifique aux dates (rouge ou vert) en fonction de la valeur envoyée
        const targetDates = youtubeStatsData.dates_and_texts.map(item => item[0]); // Dates envoyées par PHP
        const dateStatuses = youtubeStatsData.dates_and_texts.map(item => item[1]); // Valeurs 0 et 1

        // Créer un nouveau graphique
        chartInstance = new Chart(ctx, {
            type: 'line',
            data: {
                labels: labels, // Toutes les dates
                datasets: [{
                    label: 'Type de statistique: ' + statType,
                    data: values,
                    borderColor: 'blue',
                    fill: false
                }]
            },
            options: {
                plugins: {
                    tooltip: {
                        callbacks: {
                            // Afficher le texte correspondant dans la tooltip
                            afterLabel: function(context) {
                                const dateIndex = targetDates.indexOf(context.label);
                                if (dateIndex !== -1) {
                                    // Afficher le texte dans la tooltip
                                    return dateStatuses[dateIndex] === '1' ? 'Commentator enabled' : 'Commentator desabled';
                                }
                                return '';
                            }
                        }
                    }
                },
                scales: {
                    x: {
                        ticks: {
                            color: function(context) {
                                // Si la date est ciblée et a un statut '1', appliquez la couleur verte
                                const dateIndex = targetDates.indexOf(context.tick.label);
                                if (dateIndex !== -1) {
                                    return dateStatuses[dateIndex] === '1' ? 'green' : 'red'; // Vert si 1, Rouge si 0
                                }
                                return 'black'; // Autres dates normales
                            },
                           font: {
    weight: function(context) {
        const dateIndex = targetDates.indexOf(context.tick.label);
        if (dateIndex !== -1) {
            return 'bold';  // Mettre en gras pour les dates spécifiées
        }
        return 'normal';  // Autres dates non en gras
    },
    size: function(context) {
        const dateIndex = targetDates.indexOf(context.tick.label);
        if (dateIndex !== -1) {
            return 14;  // Taille de police pour les dates spécifiées (par exemple, 14px)
        }
        return 10;  // Autres dates auront une taille différente (par exemple, 10px)
    }
}

                        }
                    }
                }
            }
        });
    }
});
